image: cypress/browsers:node18.12.0-chrome103-ff107

stages:
  - codeStyle
  - build
  - auto-tag
  - deploy

cache:
  key: $CI_COMMIT_REF_SLUG-$CI_PROJECT_DIR
  paths:
    - .npm/

before_script:
  - cp $NPMRC_PULL ~/.npmrc
  - npm ci --cache .npm --prefer-offline --ignore-scripts

codeStyle:
  stage: codeStyle
  cache:
    key: $CI_COMMIT_REF_SLUG-$CI_PROJECT_DIR
    paths:
      - .npm/
    policy: pull
  script:
    - npm run lint
  only:
    - triggers
    - branches
  except:
    changes:
      - "CHANGELOG.md"
    refs:
      - master

buildExampleApp:
  stage: build
  cache:
    key: $CI_COMMIT_REF_SLUG-$CI_PROJECT_DIR
    paths:
      - .npm/
    policy: pull
  script:
    - npm run build-example-app
  only:
    - triggers
    - branches
  artifacts:
    paths:
      - ./dist
    expire_in: 1 hour
  except:
    changes:
      - "CHANGELOG.md"
    refs:
      - master

buildLibrary:
  stage: build
  cache:
    key: $CI_COMMIT_REF_SLUG-$CI_PROJECT_DIR
    paths:
      - .npm/
    policy: pull
  script:
    - npm run build-library
  only:
    - triggers
    - branches
  artifacts:
    paths:
      - ./dist
    expire_in: 1 hour
  except:
    changes:
      - "CHANGELOG.md"
    refs:
      - master

auto-tag:
  image: 'registry.gitlab.ics.muni.cz:443/csirt-mu-devel/csirt-mu-devel-artifact-repository/docker-common-ci:v0.1.6'
  variables:
    GIT_STRATEGY: clone
  stage: auto-tag
  script:
    - source /app/export-tag-vars.sh VERSION.txt
    - echo $TAG_VERSION && echo $TAG_MESSAGE
    - /app/import-ssh-key.sh
    - /app/prepare-git.sh
    - /app/set-version-angular.sh
    - /app/create-changelog.sh
    - /app/tag-and-push.sh
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
      changes:
        - VERSION.txt

deploy:
  stage: deploy
  cache:
    key: $CI_COMMIT_REF_SLUG-$CI_PROJECT_DIR
    paths:
      - .npm/
    policy: pull
  script:
    - cp $NPMRC_PULL ~/.npmrc
    - npm run ci-build-and-pack
    - cp $NPMRC_PUSH ~/.npmrc
    - npm run ci-publish-package
  only:
    - tags

